{
Everywhere in this program where a value is displayed in the P.S.T. window I take the floating point
value and covert it to degrees. Then I multiply it by 100 and turn it into an integer.  So if the heading
is displaying 18000 degrees it is really 180.00.  The raw values from the mag and acc are not converted to
degrees.
The Pitch and Roll value in Radians is ran through a low pass filter before it gets to the Tilt
Compensate routine.

On the 9DOF board from sparkfun the x axis from the ACC is aligned with the y axis of the MAG.  So this
means the same for the y axis on the ACC and the X axis of the MAG.

I believe this program works but I need to test it further.
}

CON
        _clkmode = xtal1 + pll16x                                               'Standard clock mode * crystal frequency = 80 MHz
        _xinfreq = 5_000_000
OHund = 100.0
Alpha = 0.01
VAR
Long MSB,LSB
Long mX,mZ,mY  
Long Azimuth
long elapsed
long aX,aY,aZ
long Roll,Pitch
long Yh,Yh1,Yh2,Xh,Xh1,Xh2
Long SPitch,CPitch,SRoll,CRoll
long aYLFS,aYFS,aXLFS,aXFS,PLFS,PFS,RLFS,RFS
long mXLFS,mXFS,mYLFS,mYFS,mZLFS,mZFS
long Debug[20]
'These are display Varibales
long DRoll,DPitch,DAzimuth
long AzimuthN             'Non-Compensated
Long Heading
OBJ
I2C      : "Basic_I2C_Driver"          
FP32F    : "Float32Full"
PST      : "Parallax Serial Terminal"

PUB Main
  waitcnt(clkfreq/100_000 + cnt)                        'Wait while compass has time to startup.
  PST.Start(115_200)                                    'Sets BaudRate for PST and Starts it.
  FP32F.Start                                           'Starts Math Engine FF32
  Configure_ADXL345                                     'Configures ADXL345
  Configure_HMC5883L                                    'Configures HMC5883L

  Repeat
    Read_ADXL345_Accelerometer
    Read_HMC5883L_Magnetometer
    Convert_2_Float
    Compute_Pitch_Roll
    Filter_Pitch_Roll_Magnetometer
    Non_Tilt_Compensated_Heading
    Tilt_Compensated_Heading
    Display_Variables
'*************************************************
Pub Configure_ADXL345
  I2C.WriteByte(16, $A6, $31 | I2C#OneAddr, %1001)
  I2C.WriteByte(16, $A6, $2C | I2C#OneAddr, %1011)
  I2C.WriteByte(16, $A6, $2D | I2C#OneAddr, %1000)
'*************************************************
Pub Configure_HMC5883L
  I2C.WriteByte(16, $3C, $00 | I2C#OneAddr, $70)
  I2C.WriteByte(16, $3C, $01 | I2C#OneAddr, $A0)
  I2C.WriteByte(16, $3C, $02 | I2C#OneAddr, $00)
'*************************************************
Pub Read_ADXL345_Accelerometer
  LSB := I2C.ReadByte(16, $A6, $32 | I2C#OneAddr)       'Reads ACC Raw X Value                            
  MSB := I2C.ReadByte(16, $A6, $33 | I2C#OneAddr)
  aX  := MSB << 8 + LSB

  LSB := I2C.ReadByte(16, $A6, $34 | I2C#OneAddr)       'Reads ACC Raw Y Value
  MSB := I2C.ReadByte(16, $A6, $35 | I2C#OneAddr)
  aY := MSB << 8 + LSB

  LSB := I2C.ReadByte(16, $A6, $36 | I2C#OneAddr)       'Reads ACC Raw Z Value                           
  MSB := I2C.ReadByte(16, $A6, $37 | I2C#OneAddr)
  aZ := MSB << 8 + LSB

  ~~aX                                                  'Extends the sign for aX,aY and aZ
  ~~aY
  ~~aZ

  Debug[0] := aX                                        'For Display in P.S.T.
  Debug[1] := aY
  Debug[2] := aZ  
'*************************************************
Pub Read_HMC5883L_Magnetometer                          
  MSB := I2C.ReadByte(16, $3C, $03 | I2C#OneAddr)       'Reads MAG Raw X Value
  LSB := I2C.ReadByte(16, $3C, $04 | I2C#OneAddr)
  mX := MSB << 8 + LSB
    
  MSB := I2C.ReadByte(16, $3C, $05 | I2C#OneAddr)       'Reads MAG Raw Z Value
  LSB := I2C.ReadByte(16, $3C, $06 | I2C#OneAddr)
  mZ := MSB << 8 + LSB
    
  MSB := I2C.ReadByte(16, $3C, $07 | I2C#OneAddr)       'Reads MAG Raw Y Value
  LSB := I2C.ReadByte(16, $3C, $08 | I2C#OneAddr)
  mY := MSB << 8 + LSB
 
  ~~mX                                                  'Extends the sign for mX,mZ and mY
  ~~mZ
  ~~mY

  Debug[3] := mX                                        'For Display in P.S.T.
  Debug[4] := mZ
  Debug[5] := mY
'*************************************************
Pub Convert_2_Float
  aX    := FP32F.FFloat(aX)                             'X is the Pitch axis for the ACC
  aY    := FP32F.FFloat(aY)                             'Y is the Roll axis for the ACC
  aZ    := FP32F.FFloat(aZ)

  mX    := FP32F.FFloat(mX)                             'X is the Roll axis for the MAG
  mZ    := FP32F.FFloat(mZ)
  mY    := FP32F.FFloat(mY)                             'Y is the Pitch axis for the MAG
'*************************************************
Pub Compute_Pitch_Roll
  Pitch := FP32F.ATan2(aX,aZ)                           'This is still in Radians I believe.
  Roll  := FP32F.ATan2(aY,aZ)                           'This is still in Radians I believe.

  Debug[6] := FP32F.Degrees(Pitch)                      'Displays Pitch in Degrees.  Pitch forward on X axis is + on my ACC.
  Debug[6] := FP32F.FMul(OHund,Debug[6])
  Debug[6] := FP32F.FRound(Debug[6])

  Debug[7] := FP32F.Degrees(Roll)                       'Displays Roll in Degrees.  Roll Left on Y axis is + on my ACC.
  Debug[7] := FP32F.FMul(OHund,Debug[7])
  Debug[7] := FP32F.FRound(Debug[7])
'*************************************************
Pub Filter_Pitch_Roll_Magnetometer

  PFS := FP32F.FSub(Pitch, PLFS)                        'Filters Pitch Radians
  PFS := FP32F.FMul(Alpha,PFS)
  PFS := FP32F.FAdd(PLFS,PFS)
  'FilteredSample := LastFilteredSample + Alpha * (Ax - LastFilteredSample)
  PLFS := PFS
  Pitch := PFS

  RFS := FP32F.FSub(Roll, RLFS)                         'Filters Roll in Radians
  RFS := FP32F.FMul(Alpha,RFS)
  RFS := FP32F.FAdd(RLFS,RFS)
  'FilteredSample := LastFilteredSample + Alpha * (Ax - LastFilteredSample)
  RLFS := RFS
  Roll := RFS
'*************************************************
Pub Non_Tilt_Compensated_Heading
  AzimuthN  := FP32F.ATan2(mY,mX)                       'Azimuth in Radians Non Tilt Compensated.

  Debug[8] := FP32F.Degrees(AzimuthN)                   'This section converts Azimuth to Degrees 0 - 360.
  Debug[8] := FP32F.FMul(OHund,Debug[8])
  Debug[8] := FP32F.FRound(Debug[8])
  If Debug[8] < 0
    Debug[8] += 36000
'*************************************************
Pub Tilt_Compensated_Heading
  CPitch := FP32F.Cos(Pitch)                            'Gets my Pitch Cos and Sin Value from ACC.
  SPitch := FP32F.Sin(Pitch)

  CRoll := FP32F.Cos(Roll)                              'Gets my Roll Cos and Sin Value from ACC.
  SRoll := FP32F.Sin(Roll)
'For the 9DOF board from SparkFun I believe in these equations pitch and Roll need to be swapped everywhere.
'Xh = XM * cos(Pitch) + ZM * sin(Pitch)                  First equation broken into parts.

  'XM * cos(Pitch)
  Xh1   := FP32F.FMul(mX,CRoll)
  'ZM * sin(Pitch)
  Xh    := FP32F.FMul(mZ,SRoll)
  'Xh = XM * cos(Pitch) + ZM * sin(Pitch)
  'Xh =    Xh1          +       Xh
  Xh    := FP32F.FAdd(Xh1,Xh)

'Yh = XM * sin(Roll) * sin(Pitch) + YM * cos(Roll) - ZM * sin(Roll) * cos(Pitch)         Second Equation broken down into parts.

  'XM * sin(Roll)
  Yh1 := FP32F.FMul(mX,SPitch)

  'XM * sin(Roll) * sin(Pitch)
  'Yh1 =   Yh1    * sin(Pitch)
  Yh1 := FP32F.FMul(Yh1,SRoll)

  'YM * cos(Roll)
  Yh2 := FP32F.FMul(mY,CPitch)

  'ZM * sin(Roll)
  Yh  := FP32F.FMul(mZ,SPitch)

  'Yh = ZM * sin(Roll) * cos(Pitch)
  'Yh =        Yh      * cos(Pitch)
  Yh  := FP32F.FMul(Yh,CRoll)

  Yh1 := FP32F.FAdd(Yh1,Yh2)

  Yh  := FP32F.FSub(Yh1, Yh)

'''''''''''''Converts to Degrees and integer format'''''''''''''''''''''''
'18000 would be 180.00 degrees
  Heading := FP32F.ATan2(Yh,Xh)
  Heading := FP32F.Degrees(Heading)

  Heading := FP32F.FMul(OHund,Heading)
  Heading := FP32F.FRound(Heading)

  If Heading < 0                'Makes the heading 0 - 360 degrees instead of -180 0 180
    Heading += 36000
  
  Debug[9] := Heading



{
These are the Tilt Compensation Equations I used
Xh = XM * cos(Pitch) + ZM * sin(Pitch)
Yh = XM * sin(Roll) * sin(Pitch) + YM * cos(Roll) - ZM * sin(Roll) * cos(Pitch) 

Once we have tilt compensated Xh and Yh, we can now use the same equation as before to find our heading!

Heading = arctan(Yh/Xh)
             }
'*************************************************
'P.S.T Terminal display  
Pub Display_Variables
  PST.Clear

  PST.Str(String("aX = "))
  PST.Dec(Debug[0])
  PST.NewLine

  PST.Str(String("aY = "))
  PST.Dec(Debug[1])
  PST.NewLine

  PST.Str(String("aZ = "))
  PST.Dec(Debug[2])
  PST.NewLine

  PST.Str(String("Pitch Acc = "))
  PST.Dec(Debug[6])
  PST.NewLine

  PST.Str(String("Roll Acc = "))
  PST.Dec(Debug[7])
  PST.NewLine

  PST.Str(String("mX = "))
  PST.Dec(Debug[3])
  PST.NewLine

  PST.Str(String("mY = "))
  PST.Dec(Debug[4])
  PST.NewLine

  PST.Str(String("mZ = "))
  PST.Dec(Debug[5])
  PST.NewLine

  PST.Str(String("Azimuth Non = "))
  PST.Dec(Debug[8])
  PST.NewLine

  PST.Str(String("Azimuth Comp = "))
  PST.Dec(Debug[9])
  PST.NewLine

  waitcnt(clkfreq/10 + cnt)